﻿using System.Threading;
using DotNetBrowser;
using ProxyInterfaces;

namespace DotNetBrowserProxy
{
    public class BrowserProxy : IBrowserProxy
    {
        private Browser browser;
        private ManualResetEvent pageLoadEvent;

        public BrowserProxy()
        {
            browser = BrowserFactory.Create();
            browser.FinishLoadingFrameEvent += (sender, args) =>
            {
                if (args.IsMainFrame)
                {
                    pageLoadEvent.Set();
                }
            };
            pageLoadEvent = new ManualResetEvent(false);
        }

        public string GetWebPageHtml(string url)
        {
            pageLoadEvent.Reset();
            browser.LoadURL(url);
            pageLoadEvent.WaitOne();
            return browser.GetHTML();
        }

        public void Dispose()
        {
            browser?.Dispose();
        }
    }
}
