﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using ProxyInterfaces;

namespace SmartAssemblyObfucation
{
    class Program
    {
        static void Main(string[] args)
        {
            IBrowserProxy proxy = GetProxyFromAssembly("DotNetBrowserProxy.dll");

            string githubHtml = proxy.GetWebPageHtml("github.com");
            Console.WriteLine(githubHtml);

            proxy.Dispose();

            Console.ReadKey();
        }

        static IBrowserProxy GetProxyFromAssembly(string assemblyFileName)
        {
            if (File.Exists(assemblyFileName))
            {
                Assembly proxyAssembly = Assembly.LoadFrom(assemblyFileName);
                Type browserProxyType = proxyAssembly.GetTypes()
                    .FirstOrDefault(type => type.IsClass && type.GetInterface("IBrowserProxy") != null);

                if (browserProxyType != null)
                {
                    IBrowserProxy proxy = (IBrowserProxy) Activator.CreateInstance(browserProxyType);
                    return proxy;
                }
            }

            return null;
        }
    }
}
